%--------------------------------------------------------------------------
%   Solves the FBA at differnt points across the biofilm space
%--------------------------------------------------------------------------
function FBA_sol=test (q_Ac,q_e)
%function FBA_sol=test (q_Ac)
 
%reading the enzyme names
enzyme;

%reading the stoichiometric matrix
load WTAcFumE.txt;

%reading the constraints
load Rxnconst.txt;

%Defining the stoichiometric matrix & constraints
A=WTAcFumE;
lb=Rxnconst(:,1);   % lower bounds of the fluxes
ub=Rxnconst(:,2);   % upper bounds of the fluxes

for i=1:length(lb)
if lb(i)<=-1000
    lb(i)=-1000;
end

if ub(i)>=1000
   ub(i)=1000;
end
end

%converting MALt6 (index 377)  to MALFUM transporter
A(:,377)=zeros(length(A(:,1)),1); %zeroing out MALt6
A(512,377)=-1;%fum ex consumption
A(249,377)=1; %fum in production
A(334,377)=-1;%mala in consuption
A(524,377)=1;%external mal production

%Defining RHS
b=zeros(length(A(:,1)),1);

%Defining the objective function coefficients
C=zeros(length(lb),1);

% maximixation of biomass
C(45,1)=-1;

%setting acetate
lb(47)=-q_Ac;
ub(47)=-q_Ac;


%setting e
lb(56)=-q_e; 

% making hydrogenase reaction reversible
lb(304)=-1000;

% accounting for hydrogen secretion
lb(469)=0; ub(469)=0; % the lower and upper bounds of PDH and PDL set to zero
lb(467)=0; ub(467)=0;

lb(247)=-1000; lb(248)=-1000; % making G3PD1 and G3PD2 reversible

% set fumarate exchange to zero
lb(58)=0;
ub(58)=0;
 
% Setting ATPM flux
ub(149)=0.45;
lb(149)=0.45;

%---------------------------------linprog (cplex) method-------------------------
[xmin,fmin,status,extra]=linprog(C,[],[],A,b,lb,ub);
FBA_sol=xmin;